]> git.ipfire.org Git - thirdparty/git.git/blame - git-am.sh
Merge branch 'jc/clone'
[thirdparty/git.git] / git-am.sh
CommitLineData
d1c5f2a4
JH
1#!/bin/sh
2#
d64e6b04 3# Copyright (c) 2005, 2006 Junio C Hamano
d1c5f2a4 4
d84029b6 5USAGE='[--signoff] [--dotest=<dir>] [--utf8 | --no-utf8] [--binary] [--3way]
2092a1fe 6 [--interactive] [--whitespace=<option>] [-C<n>] [-p<n>] <mbox>...
cf1fe88c
FK
7 or, when resuming [--skip | --resolved]'
8. git-sh-setup
f9474132 9set_reflog_action am
7eff28a9 10require_work_tree
d1c5f2a4 11
d64e6b04
JH
12git var GIT_COMMITTER_IDENT >/dev/null || exit
13
d1c5f2a4
JH
14stop_here () {
15 echo "$1" >"$dotest/next"
16 exit 1
17}
18
ced9456a 19stop_here_user_resolve () {
cc120056 20 if [ -n "$resolvemsg" ]; then
a23bfaed 21 printf '%s\n' "$resolvemsg"
cc120056
SE
22 stop_here $1
23 fi
ced9456a
RS
24 cmdline=$(basename $0)
25 if test '' != "$interactive"
26 then
27 cmdline="$cmdline -i"
28 fi
29 if test '' != "$threeway"
30 then
31 cmdline="$cmdline -3"
32 fi
33 if test '.dotest' != "$dotest"
34 then
35 cmdline="$cmdline -d=$dotest"
36 fi
37 echo "When you have resolved this problem run \"$cmdline --resolved\"."
38 echo "If you would prefer to skip this patch, instead run \"$cmdline --skip\"."
39
40 stop_here $1
41}
42
d1c5f2a4
JH
43go_next () {
44 rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
45 "$dotest/patch" "$dotest/info"
46 echo "$next" >"$dotest/next"
47 this=$next
48}
49
fd7bcfb5
JH
50cannot_fallback () {
51 echo "$1"
52 echo "Cannot fall back to three-way merge."
53 exit 1
54}
55
d1c5f2a4
JH
56fall_back_3way () {
57 O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
58
59 rm -fr "$dotest"/patch-merge-*
60 mkdir "$dotest/patch-merge-tmp-dir"
61
62 # First see if the patch records the index info that we can use.
5be60078 63 git apply -z --index-info "$dotest/patch" \
fd7bcfb5
JH
64 >"$dotest/patch-merge-index-info" &&
65 GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
5be60078 66 git update-index -z --index-info <"$dotest/patch-merge-index-info" &&
fd7bcfb5 67 GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
5be60078 68 git write-tree >"$dotest/patch-merge-base+" ||
b1440cc8 69 cannot_fallback "Repository lacks necessary blobs to fall back on 3-way merge."
fd7bcfb5
JH
70
71 echo Using index info to reconstruct a base tree...
72 if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
5be60078 73 git apply $binary --cached <"$dotest/patch"
d1c5f2a4 74 then
d1c5f2a4
JH
75 mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
76 mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
fd7bcfb5
JH
77 else
78 cannot_fallback "Did you hand edit your patch?
79It does not apply to blobs recorded in its index."
d1c5f2a4
JH
80 fi
81
82 test -f "$dotest/patch-merge-index" &&
5be60078 83 his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
d1c5f2a4
JH
84 orig_tree=$(cat "$dotest/patch-merge-base") &&
85 rm -fr "$dotest"/patch-merge-* || exit 1
86
87 echo Falling back to patching base and 3-way merge...
88
89 # This is not so wrong. Depending on which base we picked,
90 # orig_tree may be wildly different from ours, but his_tree
91 # has the same set of wildly different changes in parts the
579c9bb1 92 # patch did not touch, so recursive ends up canceling them,
d1c5f2a4
JH
93 # saying that we reverted all those changes.
94
579c9bb1
SP
95 eval GITHEAD_$his_tree='"$SUBJECT"'
96 export GITHEAD_$his_tree
97 git-merge-recursive $orig_tree -- HEAD $his_tree || {
b4372ef1 98 git rerere
d1c5f2a4
JH
99 echo Failed to merge in the changes.
100 exit 1
101 }
579c9bb1 102 unset GITHEAD_$his_tree
d1c5f2a4
JH
103}
104
105prec=4
3f0a8f3c
GP
106dotest=.dotest sign= utf8=t keep= skip= interactive= resolved= binary=
107resolvemsg= resume=
67dad687 108git_apply_opt=
d1c5f2a4
JH
109
110while case "$#" in 0) break;; esac
111do
112 case "$1" in
113 -d=*|--d=*|--do=*|--dot=*|--dote=*|--dotes=*|--dotest=*)
8096fae7 114 dotest=`expr "z$1" : 'z-[^=]*=\(.*\)'`; shift ;;
d1c5f2a4
JH
115 -d|--d|--do|--dot|--dote|--dotes|--dotest)
116 case "$#" in 1) usage ;; esac; shift
117 dotest="$1"; shift;;
118
119 -i|--i|--in|--int|--inte|--inter|--intera|--interac|--interact|\
120 --interacti|--interactiv|--interactive)
121 interactive=t; shift ;;
122
087b6742
JH
123 -b|--b|--bi|--bin|--bina|--binar|--binary)
124 binary=t; shift ;;
125
d1c5f2a4
JH
126 -3|--3|--3w|--3wa|--3way)
127 threeway=t; shift ;;
128 -s|--s|--si|--sig|--sign|--signo|--signof|--signoff)
129 sign=t; shift ;;
130 -u|--u|--ut|--utf|--utf8)
3cf167ba 131 utf8=t; shift ;; # this is now default
d84029b6
JH
132 --no-u|--no-ut|--no-utf|--no-utf8)
133 utf8=; shift ;;
d1c5f2a4
JH
134 -k|--k|--ke|--kee|--keep)
135 keep=t; shift ;;
136
0c15cc92
JH
137 -r|--r|--re|--res|--reso|--resol|--resolv|--resolve|--resolved)
138 resolved=t; shift ;;
139
d1c5f2a4
JH
140 --sk|--ski|--skip)
141 skip=t; shift ;;
142
2092a1fe 143 --whitespace=*|-C*|-p*)
67dad687 144 git_apply_opt="$git_apply_opt $1"; shift ;;
8c31cb82 145
cc120056 146 --resolvemsg=*)
a23bfaed 147 resolvemsg=${1#--resolvemsg=}; shift ;;
cc120056 148
d1c5f2a4
JH
149 --)
150 shift; break ;;
151 -*)
152 usage ;;
153 *)
154 break ;;
155 esac
156done
157
0c15cc92
JH
158# If the dotest directory exists, but we have finished applying all the
159# patches in them, clear it out.
d1c5f2a4
JH
160if test -d "$dotest" &&
161 last=$(cat "$dotest/last") &&
162 next=$(cat "$dotest/next") &&
163 test $# != 0 &&
164 test "$next" -gt "$last"
165then
166 rm -fr "$dotest"
167fi
168
169if test -d "$dotest"
170then
c95b1389
JH
171 case "$#,$skip$resolved" in
172 0,*t*)
173 # Explicit resume command and we do not have file, so
174 # we are happy.
175 : ;;
176 0,)
177 # No file input but without resume parameters; catch
178 # user error to feed us a patch from standard input
179 # when there is already .dotest. This is somewhat
180 # unreliable -- stdin could be /dev/null for example
181 # and the caller did not intend to feed us a patch but
182 # wanted to continue unattended.
183 tty -s
184 ;;
185 *)
186 false
187 ;;
188 esac ||
189 die "previous dotest directory $dotest still exists but mbox given."
271440e3 190 resume=yes
d1c5f2a4 191else
0c15cc92
JH
192 # Make sure we are not given --skip nor --resolved
193 test ",$skip,$resolved," = ,,, ||
cc120056 194 die "Resolve operation not in progress, we are not resuming."
d1c5f2a4
JH
195
196 # Start afresh.
197 mkdir -p "$dotest" || exit
198
5be60078 199 git mailsplit -d"$prec" -o"$dotest" -b -- "$@" > "$dotest/last" || {
d1c5f2a4
JH
200 rm -fr "$dotest"
201 exit 1
202 }
203
8c31cb82
JH
204 # -b, -s, -u, -k and --whitespace flags are kept for the
205 # resuming session after a patch failure.
0c15cc92 206 # -3 and -i can and must be given when resuming.
087b6742 207 echo "$binary" >"$dotest/binary"
8c31cb82 208 echo " $ws" >"$dotest/whitespace"
d1c5f2a4
JH
209 echo "$sign" >"$dotest/sign"
210 echo "$utf8" >"$dotest/utf8"
211 echo "$keep" >"$dotest/keep"
d1c5f2a4
JH
212 echo 1 >"$dotest/next"
213fi
214
0c15cc92
JH
215case "$resolved" in
216'')
5be60078 217 files=$(git diff-index --cached --name-only HEAD) || exit
0c15cc92
JH
218 if [ "$files" ]; then
219 echo "Dirty index: cannot apply patches (dirty: $files)" >&2
220 exit 1
221 fi
222esac
223
087b6742
JH
224if test "$(cat "$dotest/binary")" = t
225then
226 binary=--allow-binary-replacement
227fi
d1c5f2a4
JH
228if test "$(cat "$dotest/utf8")" = t
229then
230 utf8=-u
bb1091a4
JH
231else
232 utf8=-n
d1c5f2a4
JH
233fi
234if test "$(cat "$dotest/keep")" = t
235then
236 keep=-k
237fi
8c31cb82 238ws=`cat "$dotest/whitespace"`
d1c5f2a4
JH
239if test "$(cat "$dotest/sign")" = t
240then
241 SIGNOFF=`git-var GIT_COMMITTER_IDENT | sed -e '
242 s/>.*/>/
243 s/^/Signed-off-by: /'
244 `
245else
246 SIGNOFF=
247fi
d1c5f2a4
JH
248
249last=`cat "$dotest/last"`
250this=`cat "$dotest/next"`
251if test "$skip" = t
252then
b4372ef1 253 git rerere clear
d1c5f2a4 254 this=`expr "$this" + 1`
69224716 255 resume=
d1c5f2a4
JH
256fi
257
258if test "$this" -gt "$last"
259then
260 echo Nothing to do.
261 rm -fr "$dotest"
262 exit
263fi
264
265while test "$this" -le "$last"
266do
267 msgnum=`printf "%0${prec}d" $this`
268 next=`expr "$this" + 1`
269 test -f "$dotest/$msgnum" || {
69224716 270 resume=
d1c5f2a4
JH
271 go_next
272 continue
273 }
0c15cc92
JH
274
275 # If we are not resuming, parse and extract the patch information
276 # into separate files:
277 # - info records the authorship and title
278 # - msg is the rest of commit log message
279 # - patch is the patch body.
280 #
281 # When we are resuming, these files are either already prepared
282 # by the user, or the user can tell us to do so by --resolved flag.
271440e3
JH
283 case "$resume" in
284 '')
5be60078 285 git mailinfo $keep $utf8 "$dotest/msg" "$dotest/patch" \
271440e3
JH
286 <"$dotest/$msgnum" >"$dotest/info" ||
287 stop_here $this
ca193cf1
JS
288
289 # skip pine's internal folder data
290 grep '^Author: Mail System Internal Data$' \
291 <"$dotest"/info >/dev/null &&
292 go_next && continue
293
87ab7992 294 test -s $dotest/patch || {
6777c380 295 echo "Patch is empty. Was it split wrong?"
87ab7992
DZ
296 stop_here $this
297 }
5be60078 298 git stripspace < "$dotest/msg" > "$dotest/msg-clean"
271440e3
JH
299 ;;
300 esac
d1c5f2a4
JH
301
302 GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
303 GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
304 GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
e0e3ba20
JH
305
306 if test -z "$GIT_AUTHOR_EMAIL"
307 then
308 echo "Patch does not have a valid e-mail address."
309 stop_here $this
310 fi
311
2c674191 312 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
d1c5f2a4 313
4bfb6b62 314 SUBJECT="$(sed -n '/^Subject/ s/Subject: //p' "$dotest/info")"
d1c5f2a4 315 case "$keep_subject" in -k) SUBJECT="[PATCH] $SUBJECT" ;; esac
4bfb6b62
JH
316
317 case "$resume" in
318 '')
319 if test '' != "$SIGNOFF"
320 then
d1c5f2a4 321 LAST_SIGNED_OFF_BY=`
4bfb6b62
JH
322 sed -ne '/^Signed-off-by: /p' \
323 "$dotest/msg-clean" |
324 tail -n 1
d1c5f2a4 325 `
4bfb6b62
JH
326 ADD_SIGNOFF=`
327 test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
d1c5f2a4
JH
328 test '' = "$LAST_SIGNED_OFF_BY" && echo
329 echo "$SIGNOFF"
4bfb6b62
JH
330 }`
331 else
d1c5f2a4 332 ADD_SIGNOFF=
4bfb6b62
JH
333 fi
334 {
4b7cc26a 335 printf '%s\n' "$SUBJECT"
d1c5f2a4
JH
336 if test -s "$dotest/msg-clean"
337 then
338 echo
339 cat "$dotest/msg-clean"
340 fi
341 if test '' != "$ADD_SIGNOFF"
342 then
343 echo "$ADD_SIGNOFF"
344 fi
4bfb6b62
JH
345 } >"$dotest/final-commit"
346 ;;
0c15cc92 347 *)
6d28644d 348 case "$resolved$interactive" in
0c15cc92
JH
349 tt)
350 # This is used only for interactive view option.
5be60078 351 git diff-index -p --cached HEAD >"$dotest/patch"
0c15cc92
JH
352 ;;
353 esac
4bfb6b62 354 esac
d1c5f2a4 355
4bfb6b62 356 resume=
d1c5f2a4
JH
357 if test "$interactive" = t
358 then
a1451104
JH
359 test -t 0 ||
360 die "cannot be interactive without stdin connected to a terminal."
d1c5f2a4
JH
361 action=again
362 while test "$action" = again
363 do
364 echo "Commit Body is:"
365 echo "--------------------------"
366 cat "$dotest/final-commit"
367 echo "--------------------------"
9754563c 368 printf "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
d1c5f2a4
JH
369 read reply
370 case "$reply" in
f89ad67f
JH
371 [yY]*) action=yes ;;
372 [aA]*) action=yes interactive= ;;
373 [nN]*) action=skip ;;
ef0c2abf 374 [eE]*) git_editor "$dotest/final-commit"
d1c5f2a4 375 action=again ;;
f89ad67f
JH
376 [vV]*) action=again
377 LESS=-S ${PAGER:-less} "$dotest/patch" ;;
378 *) action=again ;;
d1c5f2a4
JH
379 esac
380 done
381 else
382 action=yes
383 fi
384
385 if test $action = skip
386 then
387 go_next
388 continue
389 fi
390
391 if test -x "$GIT_DIR"/hooks/applypatch-msg
392 then
393 "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
394 stop_here $this
395 fi
396
397 echo
4b7cc26a 398 printf 'Applying %s\n' "$SUBJECT"
d1c5f2a4
JH
399 echo
400
0c15cc92
JH
401 case "$resolved" in
402 '')
5be60078 403 git apply $git_apply_opt $binary --index "$dotest/patch"
0c15cc92
JH
404 apply_status=$?
405 ;;
406 t)
407 # Resolved means the user did all the hard work, and
408 # we do not have to do any patch application. Just
409 # trust what the user has in the index file and the
410 # working tree.
411 resolved=
5be60078 412 git diff-index --quiet --cached HEAD && {
64646d11 413 echo "No changes - did you forget to use 'git add'?"
ced9456a 414 stop_here_user_resolve $this
06aff47b 415 }
5be60078 416 unmerged=$(git ls-files -u)
c1d1128b
JH
417 if test -n "$unmerged"
418 then
419 echo "You still have unmerged paths in your index"
64646d11 420 echo "did you forget to use 'git add'?"
ced9456a 421 stop_here_user_resolve $this
c1d1128b 422 fi
0c15cc92 423 apply_status=0
b4372ef1 424 git rerere
0c15cc92
JH
425 ;;
426 esac
427
d1c5f2a4
JH
428 if test $apply_status = 1 && test "$threeway" = t
429 then
73319032 430 if (fall_back_3way)
d1c5f2a4 431 then
73319032
JH
432 # Applying the patch to an earlier tree and merging the
433 # result may have produced the same tree as ours.
5be60078 434 git diff-index --quiet --cached HEAD && {
06aff47b
AR
435 echo No changes -- Patch already applied.
436 go_next
437 continue
438 }
73319032
JH
439 # clear apply_status -- we have successfully merged.
440 apply_status=0
d1c5f2a4
JH
441 fi
442 fi
443 if test $apply_status != 0
444 then
445 echo Patch failed at $msgnum.
ced9456a 446 stop_here_user_resolve $this
d1c5f2a4
JH
447 fi
448
449 if test -x "$GIT_DIR"/hooks/pre-applypatch
450 then
451 "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
452 fi
453
5be60078 454 tree=$(git write-tree) &&
d1c5f2a4 455 echo Wrote tree $tree &&
5be60078
JH
456 parent=$(git rev-parse --verify HEAD) &&
457 commit=$(git commit-tree $tree -p $parent <"$dotest/final-commit") &&
d1c5f2a4 458 echo Committed: $commit &&
5be60078 459 git update-ref -m "$GIT_REFLOG_ACTION: $SUBJECT" HEAD $commit $parent ||
d1c5f2a4
JH
460 stop_here $this
461
462 if test -x "$GIT_DIR"/hooks/post-applypatch
463 then
464 "$GIT_DIR"/hooks/post-applypatch
465 fi
466
467 go_next
468done
469
470rm -fr "$dotest"